package ru.dbotthepony.kstarbound.defs.item

import com.google.gson.GsonBuilder
import com.google.gson.TypeAdapter
import com.google.gson.stream.JsonWriter
import ru.dbotthepony.kstarbound.io.CustomEnumTypeAdapter
import ru.dbotthepony.kstarbound.io.IStringSerializable
import ru.dbotthepony.kstarbound.registerTypeAdapter

enum class ItemRarity(val canonical: String) : IStringSerializable {
	COMMON("Common"),
	UNCOMMON("Uncommon"),
	RARE("Rare"),
	LEGENDARY("Legendary"),
	ESSENTIAL("Essential");

	override fun match(name: String): Boolean {
		return name == this.canonical || name.lowercase() == this.name.lowercase()
	}

	override fun write(out: JsonWriter) {
		out.value(canonical)
	}

	companion object {
		val ADAPTER: TypeAdapter<ItemRarity> = CustomEnumTypeAdapter(values()).nullSafe()

		fun registerGson(gsonBuilder: GsonBuilder) {
			gsonBuilder.registerTypeAdapter(ADAPTER)
		}
	}
}
